sc::RefSCDimension Class Reference

The RefSCDimension class is a smart pointer to an SCDimension specialization. More...

`#include <dim.h>`

Inheritance diagram for sc::RefSCDimension:
[legend]
Collaboration diagram for sc::RefSCDimension:
[legend]

## Public Member Functions

| RefSCDimension ()
| Initializes the dimension pointer to 0. More...
| RefSCDimension (const RefSCDimension &d)
| Make this and d refer to the same SCDimension.
| RefSCDimension (SCDimension *d)
| Make this refer to d.
RefSCDimension & | operator= (SCDimension *d)
| Make this refer to d.
RefSCDimension & | operator<< (RefCount *)
RefSCDimension & | operator<< (const RefBase &)
RefSCDimension & | operator= (const RefSCDimension &d)
| Make this and d refer to the same SCDimension.
| operator int () const
| Return the dimension.
int | n () const
void | print (std::ostream &o=ExEnv::out0()) const
Public Member Functions inherited from sc::Ref< SCDimension >
| Ref ()
| Create a reference to a null object.
| Ref (SCDimension *a)
| Create a reference to the object a.
| Ref (const Ref< SCDimension > &a)
| Create a reference to the object referred to by a.
| Ref (const Ref< A > &a)
| Create a reference to the object referred to by a.
| ~Ref ()
| Create a reference to the object a. More...
SCDimension * | operator-> () const
| Returns the reference counted object. More...
SCDimension * | pointer () const
| Returns a pointer the reference counted object.
RefCount * | parentpointer () const
| Implements the parentpointer pure virtual in the base class.
| operator SCDimension * () const
SCDimension & | operator* () const
| Returns a C++ reference to the reference counted object. More...
int | null () const
| Return 1 if this is a reference to a null object. More...
int | nonnull () const
| Return !null().
int | operator== (const Ref< A > &a) const
| A variety of ordering and equivalence operators are provided using the Identity class. More...
int | operator>= (const Ref< A > &a) const
int | operator<= (const Ref< A > &a) const
int | operator> (const Ref< A > &a) const
int | operator< (const Ref< A > &a) const
int | operator!= (const Ref< A > &a) const
int | compare (const Ref< SCDimension > &a) const
| Compare two objects returning -1, 0, or 1. More...
void | clear ()
| Refer to the null object.
Ref< SCDimension > & | operator= (const Ref< SCDimension > &c)
| Assignment to c.
Ref< SCDimension > & | operator= (const Ref< A > &c)
| Assignment to c.
Ref< SCDimension > & | operator= (SCDimension *cr)
| Assignment to cr.
Ref< SCDimension > & | operator<< (const RefBase &a)
| Assignment to the object that a references using dynamic_cast.
Ref< SCDimension > & | operator<< (RefCount *a)
| Assigns to the given base class pointer using dynamic_cast. More...
void | assign_pointer (SCDimension *cr)
| Assignment to cr.
void | check_pointer () const
| Check the validity of the pointer.
void | ref_info (std::ostream &os) const
| Print information about the reference to os.
void | warn (const char *s) const
| Print a warning concerning the reference.
Public Member Functions inherited from sc::RefBase
void | require_nonnull () const
| Requires that a nonnull reference is held. More...

## Additional Inherited Members

Protected Member Functions inherited from sc::RefBase
void | warn (const char *msg) const
| Print a warning message.
void | warn_ref_to_stack () const
| Called when stack data is referenced.
void | warn_skip_stack_delete () const
| Called when the deletion of stack data is skipped.
void | warn_bad_ref_count () const
| Called when the reference count is corrupted.
void | ref_info (RefCount *p, std::ostream &os) const
| Print information about the reference.
void | ref_info (std::ostream &os) const
void | check_pointer () const
void | reference (RefCount *)
int | dereference (RefCount *)

## Detailed Description

The RefSCDimension class is a smart pointer to an SCDimension specialization.

## Constructor & Destructor Documentation

sc::RefSCDimension::RefSCDimension | ( |  | ) |

Initializes the dimension pointer to 0.

The reference must be initialized before it is used.

The documentation for this class was generated from the following file:

- dim.h